<template>
	<view class="container">
		<view class="page-body">
			<view class="wrapper">
				<view class="toolbar" @tap="format">
					<view :class="formats.bold ? 'ql-active' : ''" class="iconfont icon-zitijiacu" data-name="bold"></view>
					<view :class="formats.italic ? 'ql-active' : ''" class="iconfont icon-zitixieti" data-name="italic"></view>
					<view :class="formats.underline ? 'ql-active' : ''" class="iconfont icon-zitixiahuaxian" data-name="underline"></view>
					<view :class="formats.strike ? 'ql-active' : ''" class="iconfont icon-zitishanchuxian" data-name="strike"></view>
					<view :class="formats.align === 'left' ? 'ql-active' : ''" class="iconfont icon-zuoduiqi" data-name="align" data-value="left"></view>
					<view :class="formats.align === 'center' ? 'ql-active' : ''" class="iconfont icon-juzhongduiqi" data-name="align" data-value="center"></view>
					<view :class="formats.align === 'right' ? 'ql-active' : ''" class="iconfont icon-youduiqi" data-name="align" data-value="right"></view>
					<view :class="formats.align === 'justify' ? 'ql-active' : ''" class="iconfont icon-zuoyouduiqi" data-name="align" data-value="justify"></view>
					<view :class="formats.lineHeight ? 'ql-active' : ''" class="iconfont icon-line-height" data-name="lineHeight" data-value="2"></view>
					<view :class="formats.letterSpacing ? 'ql-active' : ''" class="iconfont icon-Character-Spacing" data-name="letterSpacing" data-value="2em"></view>
					<view :class="formats.marginTop ? 'ql-active' : ''" class="iconfont icon-722bianjiqi_duanqianju" data-name="marginTop" data-value="20px"></view>
					<view :class="formats.previewarginBottom ? 'ql-active' : ''" class="iconfont icon-723bianjiqi_duanhouju" data-name="marginBottom" data-value="20px"></view>
					<view class="iconfont icon-clearedformat" @tap="removeFormat"></view>
					<view :class="formats.fontFamily ? 'ql-active' : ''" class="iconfont icon-font" data-name="fontFamily" data-value="Pacifico"></view>
					<view :class="formats.fontSize === '24px' ? 'ql-active' : ''" class="iconfont icon-fontsize" data-name="fontSize" data-value="24px"></view>

					<view :class="formats.color === '#0000ff' ? 'ql-active' : ''" class="iconfont icon-text_color" data-name="color" data-value="#0000ff"></view>
					<view
						:class="formats.backgroundColor === '#00ff00' ? 'ql-active' : ''"
						class="iconfont icon-fontbgcolor"
						data-name="backgroundColor"
						data-value="#00ff00"
					></view>

					<view class="iconfont icon-date" @tap="insertDate"></view>
					<view class="iconfont icon--checklist" data-name="list" data-value="check"></view>
					<view :class="formats.list === 'ordered' ? 'ql-active' : ''" class="iconfont icon-youxupailie" data-name="list" data-value="ordered"></view>
					<view :class="formats.list === 'bullet' ? 'ql-active' : ''" class="iconfont icon-wuxupailie" data-name="list" data-value="bullet"></view>
					<view class="iconfont icon-undo" @tap="undo"></view>
					<view class="iconfont icon-redo" @tap="redo"></view>

					<view class="iconfont icon-outdent" data-name="indent" data-value="-1"></view>
					<view class="iconfont icon-indent" data-name="indent" data-value="+1"></view>
					<view class="iconfont icon-fengexian" @tap="insertDivider"></view>
					<view class="iconfont icon-charutupian" @tap="insertImage"></view>
					<view :class="formats.header === 1 ? 'ql-active' : ''" class="iconfont icon-format-header-1" data-name="header" :data-value="1"></view>
					<view :class="formats.script === 'sub' ? 'ql-active' : ''" class="iconfont icon-zitixiabiao" data-name="script" data-value="sub"></view>
					<view :class="formats.script === 'super' ? 'ql-active' : ''" class="iconfont icon-zitishangbiao" data-name="script" data-value="super"></view>
					<view class="iconfont icon-shanchu" @tap="clear"></view>
					<view :class="formats.direction === 'rtl' ? 'ql-active' : ''" class="iconfont icon-direction-rtl" data-name="direction" data-value="rtl"></view>
				</view>

				<editor
					ref="dialogInput"
					id="editor"
					class="ql-container"
					placeholder="开始输入..."
					@blur="editInput"
					showImgSize
					showImgToolbar
					showImgResize
					@statuschange="onStatusChange"
					:read-only="readOnly"
					@ready="onEditorReady"
				></editor>
			</view>
		</view>
	</view>
</template>

<script>
import webUrl from '@/common/config.js';
import qiniuUploader from '@/common/qiniuUploader.js';
// import { getEnToken } from '@/access/common.js';
export default {
	data() {
		return {
			qn_token: '',
			readOnly: false,
			formats: {},
			goods_detail: '',
			uploadtoken: '',
			goodsDescription: ''
		};
	},
	props: {
		html: {
			type: String,
			default: ''
		}
	},
	watch: {
		html(val) {
			if (val) {
				this.editorCtx.setContents({
					html: this.html
				});
			}
		}
	},
	created(options) {
		this.getQiniuToken();
	},
	methods: {
		getQiniuToken() {
			this.$u.api
				.uploadToken({
					bucket: webUrl.QINIU_KEY,
					key: 0
				})
				.then(res => {
					this.qn_token = res.data;
				});
		},
		editInput(e) {
			this.editorCtx.getContents({
				success:(res)=>{
					this.$emit('editInput', res.html);
				}
			})
		},
		readOnlyChange() {
			this.readOnly = !this.readOnly;
		},
		onEditorReady() {
			uni.createSelectorQuery()
				.in(this)
				.select('#editor')
				.context(res => {
					if (!res) return;
					this.editorCtx = res.context;
					if (this.html) {
						this.editorCtx.setContents({
							html: this.html,
							success: () => {
								uni.hideKeyboard();
								this.$refs.dialogInput.quill.blur();
							}
						});
					}
				})
				.exec();
		},
		undo() {
			this.editorCtx.undo();
		},
		redo() {
			this.editorCtx.redo();
		},
		format(e) {
			let { name, value } = e.target.dataset;
			if (!name) return;
			// console.log('format', name, value)
			this.editorCtx.format(name, value);
		},
		onStatusChange(e) {
			const formats = e.detail;
			this.formats = formats;
		},
		insertDivider() {
			this.editorCtx.insertDivider({
				success: function() {
					console.log('insert divider success');
				}
			});
		},
		clear() {
			this.editorCtx.clear({
				success: function(res) {
					console.log('clear success');
				}
			});
		},
		removeFormat() {
			this.editorCtx.removeFormat();
		},
		insertDate() {
			const date = new Date();
			const formatDate = `${date.getFullYear()}/${date.getMonth() + 1}/${date.getDate()}`;
			this.editorCtx.insertText({
				text: formatDate
			});
		},
		// 上传图片
		insertImage() {
			uni.chooseImage({
				count: 9,
				success: async res => {
					res.tempFilePaths.forEach(imgPath => {
						this.upImg(imgPath);
					});
				}
			});
		},
		async upImg(imgPath) {
			// const imgPath = res.tempFilePaths[0]; //选择图片的路径
			const imgName = imgPath.split('/')[imgPath.split('/').length - 1];
			const key = `${this.$store.state.enToken}/${imgName}`; //图片和企业token拼接 为自定义文件名

			let domain = webUrl.QN_UP; //文件上传地址
			let token = this.qn_token; //token为七牛云的token一般由后台接口提供
			let filePath = imgPath; //为需要上传的文件
			uni.showLoading();
			qiniuUploader.upload(
				filePath,
				res => {
					//图片上传完成后返回值
					// 压缩图片
					uni.hideLoading();
					const uploadPicUrl = `${webUrl.QINIU_URL}/${res.key}?imageView2/2/w/750/h/750`;
					// console.log(uploadPicUrl);
					this.editorCtx.insertImage({
						src: uploadPicUrl,
						width:'100%',
						alt: '图像',
						success: function() {
							console.log('图像上传成功');
						}
					});
					// this.$emit('uploadSuccess', imgData);
				},
				error => {
					uni.hideLoading();
					// resolve(error)
				},
				{
					region: 'SCN', // （必须填写正确）ECN, SCN, NCN, NA, ASG，分别对应七牛的：华东，华南，华北，北美，新加坡 5 个区域
					domain: domain, // // bucket 域名，下载资源时用到。如果设置，会在 success callback 的 res 参数加上可以直接使用的 ImageURL                                         字  段。否则需要自己拼接
					key: key, // [非必须]自定义文件 key。如果不设置，默认为使用微信小程序 API 的临时文件名
					// 以下方法三选一即可，优先级为：uptoken > uptokenURL > uptokenFunc
					uptoken: token // 由其他程序生成七牛 uptoken
				},
				res => {
					uni.hideLoading();
					//上传进度
					if (res.progress === 100) {
						// resolve(keys);
					}
				}
			);
		}
	}
};
</script>

<style>
@import './editor-icon.css';

.wrapper {
	padding: 5px;
}

.iconfont {
	display: inline-block;
	padding: 22rpx;
	/* width: 24px; */
	/* height: 24px; */
	cursor: pointer;
	font-size: 20px;
}

.toolbar {
	box-sizing: border-box;
	border-bottom: 0;
	font-family: 'Helvetica Neue', 'Helvetica', 'Arial', sans-serif;
}

.ql-container {
	box-sizing: border-box;
	padding: 12px 15px;
	width: 100%;
	min-height: 30vh;
	height: auto;
	background: #fff;
	font-size: 16px;
	line-height: 1.5;
	border: 1px solid #eee;
}

.ql-active {
	color: #06c;
}
</style>
